%{
#include <stdio.h>
#include <string.h>

#include "BTree.h"
#include "global.h"

#ifdef __BORLANDC__
#include "syntax_t.h"
#else
#include "syntax.tab.h"
#endif

int yyparse( void );

int parsing_line;

//<INITIAL>"\\"([^"\\"]|"\\\\")*\\ 	{ yylval.str = StringBuf::strDup( yytext ); return T_Ident; }

%}

%option noyywrap
%x longid
%x args

%%

<INITIAL>\\([^\\]|\\\\)*\\ 	{ yylval.str = StringBuf::strDup( yytext ); return T_Ident; }
<INITIAL>"\""([^\"])*"\"" 	{ yylval.str = StringBuf::strDup( yytext ); return T_Ident; }

<INITIAL>"&"		{return T_And;}
<INITIAL>"|"		{return T_Or;}
<INITIAL>"!"            {return T_Not;}
<INITIAL>"="            {return '=';}
<INITIAL>"("            {return '(';}
<INITIAL>")"            {return ')';}
<INITIAL>";"            {return ';';}
<INITIAL>","            {return ',';}
<INITIAL>"t"            {return 't';}
<INITIAL>"t-1"            {return T_t_1;}
<INITIAL>[a-zA-Z_][a-zA-Z0-9_]* { yylval.str = StringBuf::strDup( yytext ); return T_Ident;}
<INITIAL>-?[0-9]+	{ yylval.str = StringBuf::strDup( yytext ); return T_Int; }
<INITIAL>[ \t\x0d]
<INITIAL>[\n]           { parsing_line++; }
<INITIAL>"--".*"\n"	{ yylval.str = StringBuf::strDup( yytext ); parsing_line++; return T_Comment;}

.       {  yylval.ch = yytext[0]; return T_Anything; }

%%

//{ fprintf( stderr, "Error in line %d: Unrecognized character: \"%c\"\n", parsing_line, yytext[0] ); abort(); }

char *modelName = "main";

void printUsage();

main( int argcnt, char **arg )
{

        char *fname[2] = { 0 };

        int i, f;
        for( i = 1, f = 0; i < argcnt; i++ ) {
                if( !strcmp( arg[i], "-m" ) && i+1 < argcnt ) {
                        modelName = arg[i+1];
                        i++;
                }
                else if( !strcmp( arg[i], "-h" ) ||  !strcmp( arg[i], "-help" ) ||  !strcmp( arg[i], "--help" )) {
                        printUsage();
                        return 1;
                }
		else {
                        if( f < 2 ) {
                                fname[f] = arg[i];
                                f++;
                        } else {
	                        fprintf( stderr, "Invalid option or wrong argument: %s\n", arg[i] );
        	                printUsage();
                	        return( 1 );
                        }
                }
        }

        if( f != 2 ) {
                printUsage();
                return 1;
        }

//        if( f>=1 ) {
                yyin = fopen( fname[0], "r" );
                if( yyin == 0 ) {
                        fprintf( stderr, "Can not open file for reading: %s\n", fname[0] );
                        return( 1 );
                }
  //      }
    //    if( f==2 ) {
                convOut = fopen( fname[1], "w" );
                if( convOut == 0 ) {
                        fprintf( stderr, "Can not open file for reading: %s\n", fname[1] );
                        return( 1 );
                }
      //  } else convOut = stdout;



        parsing_line = 1;
        if( yyparse() != 0 ) return 1;

        return 0;
}

void printUsage()
{
        fprintf( stderr, "Usage: bnf2slif {input file} {output file} "
                        "[-m {model name}]\n\n" );

}
