#ifndef ALLOCATOR_H
#define ALLOCATOR_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>    

// extern int parsing_line;


class MemBlock {
	MemBlock *next;
	void *data;
public:
	MemBlock( int size ) : next( 0 ), data( 0 )
	{
//	    fprintf( stderr, "Trying to allocate memory %d\n", parsing_line );
	data = malloc( size );
            memset( data, 0, size );
	    if( !data ) {
		fprintf( stderr, "Not enough memory!\n" );
		abort();
	    }
	}
	~MemBlock()
	{
  //      fprintf( stderr, "Free\n" );
		free( data );
	}
	void* getData()
	{
		return data;
	}
	void append( MemBlock *m )
	{
	MemBlock *c = this;
	while( c->next != 0 ) c = c->next;
		c->next = m;
	}
	void removeAllNext()
	{
	MemBlock *tr = next;
	while( tr ) {
		MemBlock *s = tr;
		tr = tr->next;
            delete s;
	}
        next = 0;
    }
};

/**
 Klasa do efektywnego dynamicznego przydzialy pamieci.
 */

class Allocator
{

	MemBlock *firstBlock;
	char *max, *ptr, *d;
	int size;

public:
	Allocator( int size = 32000 ) : size( size )
	{
		firstBlock = new MemBlock( size );
		clear();
	}
	~Allocator( )
	{
		delete firstBlock;
	}
	void clear( void )
	{

		firstBlock->removeAllNext();
	ptr = (char*)firstBlock->getData();
		max = ptr + size;
	}

	/**
	 Zwraca bufor o dlugosci 'len' bajtow
	 */
	char *get( int len )
	{

	if( ptr + len >= max ) {
		MemBlock *nmb = new MemBlock( size );
		firstBlock->append( nmb );
		ptr = (char*)nmb->getData();
		max = ptr + size;
	}
	char *ret = ptr;
	ptr += len;
	return ret;

	}


};


#endif
